/////////////////////////////////////////////////////////
// Actor.h - Definition of the Actor Class
// Tylor Emmett
// GSP 281 - 10/1/14
/////////////////////////////////////////////////////////

#pragma once

#include "Location.h"
#include "ElevatorData.h"

//Forward declaration
class ElevatorCar;

class Actor
{
protected:
	Location*		m_Location;				//Actors current location
	__int64			m_TargetFloor;			//Floor actor needs to go to
	ElevatorData	m_CurrentElevatorData;	//Data being collected for output
	__int64			m_ID;					//Actor's ID
	bool			m_bQueued;				//Is actor already queued?

public:
	virtual void Update(float dt) = 0;		//Called once per frame to update actor. Must be overriden in child class.
	void CallElevator();					//Called when Actor needs to change floors.
	void BoardElevator(ElevatorCar* target);//Called when entering an elevator.
	void DepartElevator();					//Called when leaving en elevator
	__int64 GetID();						//Returns the ID of this actor.
	__int64 GetTargetFloor();				//Returns target floor
	Actor(__int64 ID, __int64 floorTarget);	//Parameterized C-tor
private:
	Actor(){} //Private to force parameterized c-tor.
};