/////////////////////////////////////////////////////////
// Builder.h - Declaration of the Building class.
// Tylor Emmett
// GSP 281 - 10/1/14
/////////////////////////////////////////////////////////

#pragma once

#include <vector>



//Forward declarations
class ElevatorCar;
class Floor;

class Building
{
	std::vector<ElevatorCar*> m_Elevators;				//List of elevators
	std::vector<Floor*> m_Floors;						//List of floors

public:
	void Update(float dt);								//Updates all elevators and floors
	void Init(__int64 numFloors, __int64 numElevators);	//Initializes building. Sets number of floors and elevator cars.
	static Building* GetInstance();						//Singleton accessor
	Floor* GetFloor(__int64 floorNum);					//Returns a pointer to the requested floor.
	void Render();										//Outputs status
	unsigned GetElevatorCount();						//Returns the number of elevators.
	
private:
	//Private c-tors and assignment operator to prevent multiple objects of this type.
	Building(){}
	Building(Building&){}
	void operator=(Building&){}
};