/////////////////////////////////////////////////////////
// DataStorage.h - Declaration of the DataStorage class.
// Tylor Emmett
// GSP 281 - 10/1/14
/////////////////////////////////////////////////////////

#pragma once

#include "ElevatorData.h"
#include <vector>
#include <fstream>

class DataStorage
{
	std::vector<ElevatorData> m_DataCache;	//Container for all data members
public:
	void AddData(ElevatorData* data);		//Adds a data member to the cache.
	void ProcessData();						//Processes the data stored. Prints to screen and writes to file.
	static DataStorage* GetInstance();		//Accessor for singleton
	std::ofstream outputFile;				//stream for file output
	
private:
	//Private c-tors and assignment operator to prevent multiple objects of this type.
	DataStorage();
	DataStorage(DataStorage&){}
	void operator=(DataStorage&){}
};