/////////////////////////////////////////////////////////
// Floor.h - Declaration of the Floor class.
// Tylor Emmett
// GSP 281 - 10/1/14
/////////////////////////////////////////////////////////

#pragma once

#include <vector>
#include "Location.h"

class Actor;
class Employee;
class Customer;
class ElevatorCar;

class Floor : public Location
{
	std::vector<Actor*> m_UpQueue;				//List of passengers going up.
	std::vector<Actor*> m_DownQueue;			//List of passengers going down.
	__int64 m_FloorNumber;						//Floor number

public:
	void AddActor(Actor* actor);				//Add an actor to the floor. If the actor's target floor is this floor, add them to the list of people on the floor.
	void RemoveActor(Actor* actor);				//Remove an actor from the floor queues
	void LoadPassenger(ElevatorCar*);			//Tells actors to get on an elevator.
	__int64 GetFloorNum();						//Returns floor number
	Floor(__int64 floorNum);					//Parameterized c-tor
	void Render();								//Outputs data to screen
	bool HasUpQueue();							//Has passengers waiting to go up
	bool HasDownQueue();						//Has passengers waiting to go down.
	void Update(float dt){}

private:
	Floor(){}									//Private C-tor to force parameterized c-tor.
	
};

//Only uses the UpQueue and sets floor number to 1.
class GroundFloor : public Floor
{
public:
	GroundFloor();
};