/////////////////////////////////////////////////////////
// Model.h - Delecaration for the Model class.
// Tylor Emmett
// GSP 281 - 10/1/14
/////////////////////////////////////////////////////////

#pragma once

#define START_TIME_SECONDS 26700 //Simulation starts at 7:25am.
#define END_TIME_SECONDS 63200 //Simulation ends at 5:35pm.
#define CURRENT_SIM_TIME Model::GetInstance()->GetSimulationTime() //Shortcut to current time.

class Model
{
	bool m_bSimulationRunning;	//Simulation state. Either running or not.

	//Timing data
	__int64 m_StartingCount;	//CPU Count at the start of the simulation (0).
	__int64 m_CurrentCount;		//Current simulation count.
	float m_SecondsPerCount;	//Seconds per CPU count.
public:
	void BeginSimulation();		//Initializes simulation and contains main logic loop
	void EndSimulation();		//Turns off the simulation state.
	float GetSimulationTime();	//Returns the elapsed time since the simulation started.
	void ShowSimulationTime();  //Ouputs the simulation time to screen in 24 hour format.
	static Model* GetInstance();//Singleton Accessor

private:
	void Update(float dt);		//Updates all objects
	void Render();				//Renders/displays all data to screen.
	//Private c-tor, copy c-tor and assignment operator to avoid multiple instances.
	Model();
	Model(Model&){}
	void operator=(Model&){}
};